<template>
  <fieldset
    class="fr-fieldset"
    aria-labelledby="organisation-follow-up-types-legend"
  >
    <legend
      id="organisation-follow-up-types-legend"
      class="fr-fieldset__legend fr-h4"
    >
      Types d'accompagnement proposés par ma structure
    </legend>
    <div class="fr-fieldset__element">
      <AtomMultiSelect
        name="legalFollowUpTypes"
        label="Aides légales"
        :options="legalOptions"
        :model-value="initialLegalSelectedIds"
        label-class="fr-h6"
        :disabled-options="initialSelectedIdsAlreadyUsed"
        hint="Vous ne pouvez pas désélectionner un type d'accompagnement qui a déjà été associé à une synthèse d'entretien ou une instruction de demande d'aide."
      />
    </div>
    <div class="fr-fieldset__element">
      <AtomMultiSelect
        class="fr-mb-1w"
        name="optionalFollowUpTypes"
        label="Aides facultatives"
        :options="optionalOptions"
        :model-value="initialOptionalSelectedIds"
        label-class="fr-h6"
        :disabled-options="initialSelectedIdsAlreadyUsed"
        hint="Vous ne pouvez pas désélectionner un type d'accompagnement qui a déjà été associé à une synthèse d'entretien ou une instruction de demande d'aide."
      />
    </div>

    <button
      v-show="!isAdding"
      class="fr-btn fr-btn--tertiary-no-outline fr-btn--icon-left fr-icon-add-circle-line"
      type="button"
      @click="isAdding = true"
    >
      Ajouter une aide facultative
    </button>

    <div
      v-show="isAdding"
      class="fr-fieldset__element"
    >
      <FollowUpTypeForm @add-follow-up-type="onAddOptionalFollowUpType" />
    </div>
  </fieldset>
</template>

<script setup>
  import { toOptions } from '~/utils'
  import {
    LEGAL_FOLLOW_UP_TYPE_VALUE,
    OPTIONAL_FOLLOW_UP_TYPE_VALUE
  } from '~/utils/constants/follow-up-type'
  import { getRandomId } from '~/utils/random'

  const props = defineProps({
    followUpTypes: { type: Array, required: true },
    organisationFollowUpTypes: { type: Array, required: true }
  })

  const emit = defineEmits(['followUpTypeCreated'])

  const optionalFollowUpTypes = ref(
    getOptionalFollowUpTypes(props.followUpTypes)
  )
  const isAdding = ref(false)

  const legalFollowUpTypes = computed(() =>
    props.followUpTypes.filter(
      ({ type }) => type === LEGAL_FOLLOW_UP_TYPE_VALUE
    )
  )

  const initialLegalSelectedIds = computed(() =>
    legalFollowUpTypes.value.filter(isInitiallySelected).map(({ id }) => id)
  )

  const initialOptionalSelectedIds = computed(() =>
    optionalFollowUpTypes.value.filter(isInitiallySelected).map(({ id }) => id)
  )

  const legalOptions = computed(() =>
    toOptions(legalFollowUpTypes.value, 'id', 'name')
  )

  const optionalOptions = computed(() =>
    toOptions(optionalFollowUpTypes.value, 'id', 'name')
  )

  const initialSelectedIdsAlreadyUsed = computed(() =>
    props.followUpTypes
      .filter(isInitiallySelected)
      .filter(
        f => parseInt(f.follow_ups_count) || parseInt(f.help_requests_count)
      )
      .map(({ id }) => id)
  )

  watch(
    () => props.followUpTypes,
    followUpTypes => {
      optionalFollowUpTypes.value = getOptionalFollowUpTypes(followUpTypes)
    },
    { deep: true }
  )

  function getOptionalFollowUpTypes(followUpTypes) {
    return followUpTypes.filter(
      ({ type }) => type === OPTIONAL_FOLLOW_UP_TYPE_VALUE
    )
  }

  function onAddOptionalFollowUpType(name) {
    const newFollowUpType = {
      id: getRandomId('follow-up-type-'),
      name,
      type: OPTIONAL_FOLLOW_UP_TYPE_VALUE
    }
    optionalFollowUpTypes.value.push(newFollowUpType)
    isAdding.value = false
    emit('followUpTypeCreated', newFollowUpType)
  }

  function isInitiallySelected({ id: followUpTypeId }) {
    return props.organisationFollowUpTypes.some(
      f => followUpTypeId === f.follow_up_types_id
    )
  }
</script>
